# encoding: utf8
#
#    Implementación de una cola
#    doblemente ligada en python
#    Fraga 12/10/2017
#

class Nodo :
	def __init__( self, x, y ) :
		self.x = x
		self.y = y
		self.psig = None
		self.pant = None

class ColaDobleL :
	def __init__( self ) :
		self.frente = None
		self.atras = None

	def insertar_frente( self, nodo ) :
		if nodo is not None :
			if self.frente is None :
				self.frente = nodo
				self.atras = nodo
			else :
				nodo.psig = self.frente
				self.frente.pant = nodo
				self.frente = nodo

	def insertar_atras( self, nodo ) :
		if nodo is not None :
			if self.frente is None : 
				self.frente = nodo
				self.atras = nodo
			else :
				nodo.pant = self.atras
				self.atras.psig = nodo
				self.atras = nodo

	# Inserta el nodo pnodo después del nodo p.
	# p debe ser un nodo que exista (no puede ser NULL)
	def insertar_despues( self, p, pnodo ) :
		if p is not self.atras  :
			pnodo.psig = p.psig
			p.psig.pant = pnodo
			pnodo.pant = p
			p.psig = pnodo
		else :
			self.insertar_atras( pnodo )

	# Inserta el nodo pnodo antes del nodo p.
	# p debe ser un nodo que exista (no puede ser NULL)
	def insertar_antes( self, p, pnodo ) :
		if p is not self.frente :
			pnodo.psig = p
			pnodo.pant = p.pant
			p.pant = pnodo
			pnodo.pant.psig = pnodo
		else :
			self.insertar_frente( pnodo )


	def borra_frente( self ) :
		if self.frente is None :
			return None

		if self.frente is self.atras :
			p = self.frente
			self.frente = None
			self.atras = None
		else :
			p = self.frente
			self.frente = p.psig
			p.psig = None
			self.frente.pant = None
		
		return p

	def borra_atras( self ) :
		if self.atras is None :
			return None

		if self.frente == self.atras :
			p = self.atras
			self.atras = None
			self.frente = None
		else :
			p = self.atras
			self.atras = p.pant
			p.pant = None
			self.atras.psig = None
		
		return p

	# Buscamos el elemente que sea igual a p
	# Como no modificamos la cola, pasamos una copia
	# del frente de ella
	# Buscamos desde el frente de la cola
	def busca_nodo( self, p ) :
		L = self.frente

		while L is not None :
			if L.x == p.x and L.y == p.y :
				return L
			L = L.psig
		return None


	def imprime_cola( self ) :
		p = self.frente

		while p is not None :
			print p.x, p.y
			p = p.psig

	#
   	# Nos regresa cuantos elementos hay en la cola
	# 
	def largo( self ) :
		n=0
		p = self.frente
		while p is not None :
			n += 1
			p = p.psig

		return n
